﻿@model OperationalRiskException.Core.ViewModels.QuestionVM
@{
	ViewBag.Title = "Question";
}


<div class="row">
	<div class="col-md-12 grid-margin">
		<div class="d-flex justify-content-between flex-wrap">
			<div class="d-flex align-items-end flex-wrap">
				<div class="d-flex">
					<i class="mdi mdi-home text-muted hover-cursor"></i>
					<p class="text-muted mb-0 hover-cursor">&nbsp;/&nbsp; Question Management &nbsp;/&nbsp;</p>
					<p class="text-primary mb-0 hover-cursor">Add/View Question</p>
				</div>
			</div>

		</div>
	</div>
</div>

<div class="row">
	<div class="col-md-12 grid-margin stretch-card">
		<div class="card">
			<div class="card-body">
				<h4 class="card-title"> Create Question </h4>
				<p class="card-description">
					
				</p>

				@using (Html.BeginForm("QuestionPage", "Question", FormMethod.Post, new { @class = "forms-sample", role = "form" }))
				{
					@Html.AntiForgeryToken()

			<div class="row">
				<div class="form-group col-md-12">
					<label for="exampleInputUsername1">Question  Text</label>
					<div class="row col-md-6">
						@Html.TextAreaFor(m => m.QuestionText, new { @class = "form-control", @placeholder = "Add Question" })
						@Html.ValidationMessageFor(model => model.QuestionText, null, new { @class = "text text-danger" })
					</div>
				</div>
				<div class="form-group col-md-12">
					<label for="exampleInputUsername1"> Select Category</label>
					<div class="row col-md-6">
							@Html.DropDownListFor(m => m.CategoryId, new SelectList(ViewBag.Categories,"CategoryId", "CategoriesName"), new { @class = "form-control", @placeholder = "Add Question" })
							</div>
				</div>

			</div>



					<button type="submit" class="btn btn-primary mr-2">Add Question</button>
				}
			</div>
		</div>
	</div>
</div>
<div class="row">
	<div class="col-md-12 grid-margin stretch-card">
		<div class="card tablecontainer">
			<div class="card-body">
				<h4 class="card-title"></h4>
				<p class="card-description">
					List of Questions
				</p>
				<div class="table-responsive pt-3">
					<table class="table table-bordered" id="myTable">
						<thead>
							<tr>
								<th>
								Id
								</th>
								<th>
									Question Content
								</th>
								<th>
									Category Name
								</th>
								<th>
									Edit
								</th>
								<th>
									Delete
								</th>

							</tr>
						</thead>
						<tbody></tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>
<div id="userModal" class="modal fade">
    <div class="modal-dialog">
        <div class="modal-content" id="userModalBody">

        </div>
    </div>
</div>

<script type="text/javascript">
     function updateModal(userId) {
        $.get('@Url.Action("UpdateQuestion", "Question")', { Id: userId }, function (res) {
            $("#userModalBody").html(res);
            $("#userModal").modal("show");
           // oTable.ajax.reload();
        });
    }	
     function deleteModal(userId) {
        $.get('@Url.Action("DeleteQuestion", "Question")', { Id: userId }, function (res) {
            $("#userModalBody").html(res);
            $("#userModal").modal("show");
           // oTable.ajax.reload();
        });
    }
    var oTable;
    $(document).ready(function () {
        //  debugger;
         toastrFunction()
         oTable = $("#myTable").DataTable({
            "processing": true, // for show progress bar
            "serverSide": true, // for process server side
            "filter": true, // this is for disable filter (search box)
            "orderMulti": false, // for disable multiple column at once
            columns: [
                { 'data': 'QuestionId', 'orderable': false, visible: false },
				{ 'data': 'QuestionText' },
				{ 'data': 'CategoryName' },

                {
                    "data": "QuestionId", "width": "50px", "render": function (data) {
                            return '<button class="btn btn-primary btn-lg" style="min-height:2rem" onclick="updateModal(' + data+ ')">Edit</button>';
       
                       // return '<a class="popup" href="@Url.Action("UpdateQuestion","Question")/' + data + '">Edit</a>';  
                    }
                },
                {
                    "data": "QuestionId", "width": "50px", "render": function (data) {
                        return '<button class="btn btn-danger btn-lg" style="min-height:2rem" onclick="deleteModal(' + data+ ')">Delete</button>';
               
                       // return '<a class="popup" href="@Url.Action("DeleteQuestion","Question")/' + data + '">Delete</a>'; 
                    }
                }
                @*{
                    data: null,
                    //className: "center",
                    //defaultContent: '<a href="" class="editor_edit">Edit</a> / <a href="" class="editor_remove">Delete</a>'
  },

            ],
            "columnDefs": [{
                "targets": 4,

                "render": function (data, type, row, meta) {
                    var url = '@Url.Action("AddUser", "Usercd")';
                    return "'<a href='"url"'>Testing</a>'";
                }
            }],*@
            ],
            "delay": 150,
            "ajax": {
                "url": "@Url.Action("GetAllQuestions","Question")", 
                "type": "POST",
                "datatype": "json"
            }
        })	
    });

     function updateRecord() {
                    var form = $('form[name="updateCategoryForm"]');
         var entry = form.serialize();
         $.post('@Url.Action("UpdateQuestion", "Question")', entry, function (res) {  
            if (res.status) {
                toastr.success("Successfully Updated", "Notification");

                oTable.ajax.reload();
                $("#userModal").modal('hide');
            }
            else {
                toastr.error("Failed to update, <br> Please check if the record already existed", "Error Notification");
            }
           //
        });
    }
         function deleteRecord() {
                    var form = $('form[name="deleteCategoryForm"]');
         var entry = form.serialize();
         $.post('@Url.Action("DeleteQuestion", "Question")', entry, function (res) {  
            if (res.status) {
                toastr.success("Successfully Delete", "Notification");

                oTable.ajax.reload();
                $("#userModal").modal('hide');
            }
            else {
                toastr.error("Failed to update, <br> Please check your internet connnection", "Error Notification");
            }
           //
        });
    }
       function toastrFunction() {

         if ('@TempData["CreateQuest"]'.length > 1) {
          toastr.success('@TempData["CreateQuest"]','Notification');
         }
         else  if ('@TempData["FailedQuest"]'.length>1) {
          toastr.error('@TempData["FailedQuest"]','Notification');
       }

    }

</script>
